<template>
    <v-container fluid fill-height>
        <v-row align="center" justify="center">
            <v-col cols="12" md="4" lg="2">
                <v-text-field
                    v-model="username"
                    outlined
                    label="Username"
                    placeholder="Enter your username"
                    @keyup.enter="submitLoginFromEnter"
                />
            </v-col>
            <v-col cols="12" md="4" lg="2">
                <v-text-field
                    v-model="password"
                    outlined
                    label="Password"
                    placeholder="Enter your password"
                    type="password"
                    @keyup.enter="submitLoginFromEnter"
                />
            </v-col>
            <v-col cols="12" md="1" class="pt-0 mt-0" align="start">
                <v-btn
                    class="pa-0 ma-0 d-none d-md-block"
                    fab
                    dark
                    small
                    elevation="0"
                    @click="submitLogin"
                >
                    <v-icon dark>mdi-arrow-right</v-icon>
                </v-btn>
                <v-btn class="pa-0 ma-0 d-md-none" block dark @click="submitLogin">
                    Login
                    <v-icon dark right>mdi-arrow-right</v-icon>
                </v-btn>
                <div class="pt-4">&nbsp;</div>
            </v-col>

            <!-- <v-col cols="12" class="ma-0 pt-0">
        <v-row justify="center" align="center">
          <v-col cols="4" class="ma-0  pt-0">
            <v-btn block outlined large>Login</v-btn>
          </v-col>
        </v-row>
            </v-col>-->
        </v-row>
        <v-snackbar v-model="loginFailed" top>
            Login failed... Try again.
            <v-btn color="red" text @click="loginFailed = false">Close</v-btn>
        </v-snackbar>
    </v-container>
</template>

<script lang="ts">
import { Request } from "../api/types";

import Vue from "vue";
export default Vue.extend({
    data: () => ({
        username: "" as string,
        password: "" as string,
        loginFailed: false as boolean
    }),
    methods: {
        submitLoginFromEnter(e: KeyboardEvent) {
            if (e.keyCode === 13) {
                this.submitLogin();
            }
        },
        async submitLogin() {
            const [err, result] = await this.$store.dispatch("loginUser", {
                username: this.username,
                password: this.password
            });

            if (err) {
                this.loginFailed = true;
            } else {
                this.$router.push({ name: "projects-home" });
            }
        }
    }
});
</script>
